package cokr.xit.fims.rcvm.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.rcvm.Rcvmt;
import cokr.xit.fims.rcvm.RcvmtQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 수납 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-31	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("rcvmtMapper")
public interface RcvmtMapper extends AbstractMapper {

	/**지정한 조건에 따라 수납 대장 목록을 조회하여 반환한다.<br />
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 목록
	 */
	List<DataObject> selectRcvmtList(RcvmtQuery req);

	/**지정한 조건에 따라 수납 대장 객체들을 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 객체 목록
	 */
	List<DataObject> selectRcvmts(RcvmtQuery req);

	/**지정한 ID에 따라 수납 대장 객체를 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 객체
	 */
	default DataObject selectRcvmtInfo(RcvmtQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("R.RCVMT_ID DESC");
		}

		List<DataObject> rcvmts = selectRcvmts(req);

		return !rcvmts.isEmpty() ? rcvmts.get(0) : null;
	}

	/**수납 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertRcvmt(Rcvmt rcvmt);

	/**수납 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateRcvmt(Rcvmt rcvmt);

	/**수납 취소 정보를 수정한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	int updateRcvmtRtrcn(Rcvmt rcvmt);

	/**지정한 수납 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"rcvmt" - 수납 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteRcvmt(Rcvmt rcvmt);

	/**지정한 조건에 따라 부과 대장 객체를 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 부과 대장 객체
	 */
	DataObject selectLevyInfo(RcvmtQuery req);

}
